#include <bits/stdc++.h>

#define ll int

using namespace std;

class bacteria{
public:
    ll timeForMove, timeForGrowing;
};

ll calculatePopulation(vector<bacteria> v, int time){
    ll population = 0;

    for(bacteria b : v){
        if(time >= b.timeForMove) population++;
        if(time - b.timeForMove > b.timeForGrowing) population += pow(2, time - b.timeForMove - b.timeForGrowing + 1);
    }

    return population;
}

int main() {
    ll n, m, l = 0, r, mid, curPop; cin >> n >> m;
    vector<bacteria> bacterias(n);
    r = m;


    for(int i = 0; i < n; i++) cin >> bacterias[i].timeForMove;
    for(int i = 0; i < n; i++) cin >> bacterias[i].timeForGrowing;

    while(calculatePopulation(bacterias, r) < m) r += 10000;

    if(calculatePopulation(bacterias, r) == m) cout << r;

    while(l < r){
        mid = (l + r) / 2;
        curPop = calculatePopulation(bacterias, mid);
        if(curPop > m){
            r = mid;
            if(r - l <= 1){
                if(calculatePopulation(bacterias, l) != m) cout << -1;
                else cout << l;
                return 0;
            }
        }
        else if(curPop < m){
            l = mid;
            if(r - l <= 1){
                if(calculatePopulation(bacterias, r) != m) cout << -1;
                else cout << r;
                return 0;
            }
        }
        else {
            cout << mid;
            return 0;
        }
    }

    cout << -1;
}