#include <bits/stdc++.h>

using namespace std;

bool isPrime(int n){
    if(n == 2) return true;
    else if(n == 1) return false;

    for(int i = 2; i <= sqrt(n); i++) if(n % i == 0) return false;
    return true;
}
bool canPush(vector<int> group, int n){
    for(int i = 0; i < group.size() / 2; i++){
        if((group[i] % n == 0 && isPrime(group[i] / n)) || (n % group[i] == 0 && isPrime(n / group[i]))) return false;
    }
    return true;
}

int main() {
    int n, temp; cin >> n;
    vector<int> answer(n);
    vector<int> firstGroup;
    vector<int> secondGroup;

    for(int i = 0; i < n; i++) {
        cin >> temp;

        if(canPush(firstGroup, temp)){
            firstGroup.push_back(temp);
            answer[i] = 1;
        }
        else if(canPush(secondGroup, temp)){
            secondGroup.push_back(temp);
            answer[i] = 2;
        }
    }

    for(int i = 0; i < n; i++) cout << answer[i] << " ";
}